//
//  WDSpeedUpManager.h
//  IWangDingSDK_SCSP
//
//  Created by maoyuxiang on 2019/4/18.
//  Copyright © 2019年 iwangding. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WDSpeedUpProtocol.h"

NS_ASSUME_NONNULL_BEGIN

@interface WDSpeedUpManager : NSObject

/**
 开始查询提速状态信息

 @param target 回调代理
 */
- (void)startQueryWithTarget:(id<WDSpeedUpQueryDelegate>)target;

/**
 开始体验提速（发起体验提速，目前暂定体验测速是一天免费一次）

 @param target 回调代理
 */
- (void)startExperienceWithTarget:(id<WDSpeedUpExperienceDelegate>)target;

/**
 开始提速（发起提速）

 @param target 回调代理
 */
- (void)startSpeedUpWithTarget:(id<WDSpeedUpAccelerateDelegate>)target;

/**
 停止提速（终止当前的提速）

 @param target 回调代理
 */
- (void)stopSpeedUpWithTarget:(id<WDSpeedUpStopDelegate>)target;

/**
 提速验证（提速效果验证）

 @param target 回调代理
 */
- (void)startVerifyWithTarget:(id<WDSpeedUpVerifyDelegate>)target;

/**
 获得提速产品列表

 @param target 回调代理
 */

- (void)speedUpProductListWithTarget:(id<WDSpeedProductDelegate>)target;

@end

NS_ASSUME_NONNULL_END
