//
//  WDSpeedUpProtocol.h
//  IWangDingSDK_SCSP
//
//  Created by maoyuxiang on 2019/4/18.
//  Copyright © 2019年 iwangding. All rights reserved.
//

#ifndef WDSpeedUpProtocol_h
#define WDSpeedUpProtocol_h
#import <Foundation/Foundation.h>
#import "WDSpeedUpStatusResult.h"
#import "WDSpeedUpResponse.h"
#import "WDSpeedUpProductListResponse.h"
#import "WDSpeedUpVerifyResponse.h"

#pragma mark - WDSpeedUpQueryDelegate
/**
 查询提速状态信息回调代理
 */
@protocol WDSpeedUpQueryDelegate <NSObject>

/**
 查询开始
 */
- (void)queryStart;

/**
 查询状态成功

 @param result 查询结果
 */
- (void)querySuccessWithResult:(WDSpeedUpStatusResult *)result;

/**
 查询状态失败

 @param errorCode 错误状态码
 @param message 错误信息
 */
- (void)queryFailedWithErrorCode:(NSInteger)errorCode
                         message:(NSString *)message;

@end


#pragma mark - WDSpeedUpExperienceDelegate
/**
 体验提速回调代理
 */
@protocol WDSpeedUpExperienceDelegate <NSObject>

/**
 开始体验
 */
- (void)experienceStart;

/**
 体验提速成功

 @param result 结果
 */
- (void)experienceSuccessWithResult:(WDSpeedUpResponse *)result;

/**
 体验提速失败

 @param errorCode 错误状态码
 @param message 错误信息
 */
- (void)experienceFailedWithErrorCode:(NSInteger)errorCode message:(NSString *)message;

@end


#pragma mark - WDSpeedUpAccelerateDelegate
/**
 提速回调代理
 */
@protocol WDSpeedUpAccelerateDelegate <NSObject>

/**
 开始提速
 */
- (void)speedUpStart;

/**
 提速成功

 @param result 结果
 */
- (void)speedUpSuccessWithResult:(WDSpeedUpResponse *)result;

/**
 提速失败

 @param errorCode 错误状态码
 @param message 错误信息
 */
- (void)speedUpFailedWithErrorCode:(NSInteger)errorCode message:(NSString *)message;

@end


#pragma mark - WDSpeedUpStopDelegate
/**
 终止提速回调代理
 */
@protocol WDSpeedUpStopDelegate <NSObject>

/**
 终止提速开始
 */
- (void)stopSpeedUpStart;

/**
 终止提速成功

 @param result 结果
 */
- (void)stopSuccessWithResult:(WDSpeedUpResponse *)result;

/**
 终止提速失败

 @param errorCode 错误状态码
 @param message 错误信息
 */
- (void)stopFailedWithErrorCode:(NSInteger)errorCode message:(NSString *)message;

@end


#pragma mark - WDSpeedUpVerifyDelegate
/**
 提速验证回调代理
 */
@protocol WDSpeedUpVerifyDelegate <NSObject>

/**
 提速验证开始
 */
- (void)verifyStart;

/**
 提速验证成功

 @param result 结果
 */
- (void)verifySuccessWithResult:(WDSpeedUpVerifyResponse *)result;

/**
 提速验证失败

 @param errorCode 错误状态码
 @param message 错误信息
 */
- (void)verifyFailedWithErrorCode:(NSInteger)errorCode message:(NSString *)message;

@end


#pragma mark - WDSpeedProductDelegate

/**
 获得提速产品列表回调代理
 */
@protocol WDSpeedProductDelegate <NSObject>
/**
 开始获得提速产品列表
 */
- (void)speedProductStart;

/**
 获得提速产品列表成功

 @param result 提速产品结果
 */
- (void)speedProductSuccessWithResult:(WDSpeedUpProductListResponse *)result;

/**
 查询提速产品列表失败

 @param errorCode 错误状态码
 @param message 错误信息
 */
- (void)speedProductFailedWithErrorCode:(NSInteger)errorCode message:(NSString *)message;

@end


#endif /* WDSpeedUpProtocol_h */
